// Generated by CoffeeScript 1.11.1
(function() {
  var _addOtherUsedVersions, _groupByNameByVersion, assign, curry, flow, forEach, groupBy, isLicenseWhitelisted, isModuleWhitelisted, keyBy, map, mapValues, omit, omitBy, property, reject, shallowCopy,
    slice = [].slice;

  curry = require('lodash/curry');

  flow = require('lodash/flow');

  reject = require('lodash/fp/reject');

  map = require('lodash/fp/map').convert({
    cap: false
  });

  forEach = require('lodash/forEach');

  omit = require('lodash/omit');

  omitBy = require('lodash/fp/omitBy');

  property = require('lodash/fp/property');

  mapValues = require('lodash/fp/mapValues').convert({
    cap: false
  });

  groupBy = require('lodash/fp/groupBy');

  keyBy = require('lodash/fp/keyBy');

  isLicenseWhitelisted = require('./is-license-whitelisted');

  isModuleWhitelisted = require('./is-module-whitelisted');

  assign = require('lodash/assign');

  shallowCopy = function() {
    return assign.apply(null, [{}].concat(slice.call(arguments)));
  };

  _groupByNameByVersion = flow(groupBy('name'), mapValues(keyBy('version')));

  _addOtherUsedVersions = curry(function(moduleByNameByVersion, module) {
    var byVersion, name, version;
    name = module.name, version = module.version;
    byVersion = omit(moduleByNameByVersion[name], version);
    return shallowCopy(module, {
      otherUsedVersions: byVersion
    });
  });

  module.exports = curry(function(licenseWhitelist, exceptionWhitelist, moduleWhitelist, moduleMap) {
    var getViolatingModules, isModuleLicenseWhitelisted, moduleByNameByVersion;
    isModuleLicenseWhitelisted = flow(property('licenseDescriptor'), isLicenseWhitelisted(licenseWhitelist, exceptionWhitelist));
    moduleByNameByVersion = _groupByNameByVersion(moduleMap);
    getViolatingModules = flow(omitBy(isModuleLicenseWhitelisted), omitBy(isModuleWhitelisted(moduleWhitelist)), mapValues(_addOtherUsedVersions(moduleByNameByVersion)));
    return getViolatingModules(moduleMap);
  });

}).call(this);
