// Generated by CoffeeScript 1.11.1
(function() {
  var createEvaluator, curry, spdx,
    indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  spdx = require('spdx');

  curry = require('lodash/curry');

  createEvaluator = require('../spdx').createEvaluator;

  module.exports = curry(function(licenseWhitelist, exceptionWhitelist, licenseDescription) {
    var evaluate, inExceptionWhitelist, inWhitelist, spdxAst;
    inWhitelist = function(license) {
      return indexOf.call(licenseWhitelist, license) >= 0;
    };
    inExceptionWhitelist = function(exception) {
      return indexOf.call(exceptionWhitelist, exception) >= 0;
    };
    if (Array.isArray(licenseDescription)) {
      return licenseDescription.length > 0 && licenseDescription.some(inWhitelist);
    }
    if ((licenseDescription != null) && spdx.valid(licenseDescription)) {
      spdxAst = spdx.parse(licenseDescription);
      evaluate = createEvaluator(inWhitelist, inExceptionWhitelist);
      return evaluate(spdxAst);
    }
    return inWhitelist(licenseDescription);
  });

}).call(this);
