// Generated by CoffeeScript 1.11.1
(function() {
  var _extractLicenseName, _extractModule, _getExplicitModuleName, _mapModule, _mergeArray, extractModules, guessModuleLicense, isArray, isObject, map, mergeWith, uniq,
    indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; },
    slice = [].slice;

  isArray = require('lodash/isArray');

  isObject = require('lodash/isObject');

  mergeWith = require('lodash/mergeWith');

  uniq = require('lodash/uniq');

  map = require('lodash/fp/map').convert({
    cap: false
  });

  guessModuleLicense = require('./guess-module-license')();

  _getExplicitModuleName = function(module) {
    return module.name + "@" + module.version;
  };

  _mergeArray = function(a, b) {
    if (isArray(a)) {
      return uniq(a.concat(b));
    }
  };

  _extractLicenseName = function(license) {
    var ref;
    switch (false) {
      case !isArray(license):
        return map(_extractLicenseName, license);
      case !isObject(license):
        return (ref = license.type) != null ? ref : license.name;
      default:
        return license;
    }
  };

  _mapModule = function(module, parents) {
    var installPaths, isLicenseGuessed, licenseDescriptor, ref, ref1, ref2;
    licenseDescriptor = _extractLicenseName((ref = (ref1 = (ref2 = module.license) != null ? ref2 : module.licence) != null ? ref1 : module.licenses) != null ? ref : module.licences);
    installPaths = [module.path];
    isLicenseGuessed = false;
    if (licenseDescriptor == null) {
      licenseDescriptor = guessModuleLicense(module);
      isLicenseGuessed = licenseDescriptor != null;
    }
    return {
      name: module.name,
      explicitName: _getExplicitModuleName(module),
      version: module.version,
      licenseDescriptor: licenseDescriptor,
      isLicenseGuessed: isLicenseGuessed,
      installPaths: installPaths,
      dependencyPaths: [parents]
    };
  };

  _extractModule = function(module, parentPath) {
    var depth, explicitName, moduleMap;
    if (parentPath == null) {
      parentPath = [];
    }
    explicitName = _getExplicitModuleName(module);
    if (indexOf.call(parentPath, explicitName) >= 0) {
      return {};
    }
    depth = parentPath.length;
    moduleMap = extractModules(module.dependencies, slice.call(parentPath).concat([explicitName]));
    if (!(depth === 0 || module["private"])) {
      moduleMap[explicitName] = _mapModule(module, parentPath);
    }
    return moduleMap;
  };

  extractModules = function(modules, parentPath) {
    var module, moduleMap, name;
    if (parentPath == null) {
      parentPath = [];
    }
    moduleMap = {};
    for (name in modules) {
      module = modules[name];
      if (module.name != null) {
        moduleMap = mergeWith(moduleMap, _extractModule(module, parentPath), _mergeArray);
      }
    }
    return moduleMap;
  };

  module.exports = extractModules;

}).call(this);
