// Generated by CoffeeScript 1.11.1
(function() {
  var flow, keys, licenseMatchingMap, licensePatternOfText, map, pickBy, some, specialWords;

  flow = require('lodash/flow');

  pickBy = require('lodash/fp/pickBy');

  map = require('lodash/fp/map');

  some = require('lodash/some');

  keys = require('lodash/keys');

  specialWords = ['licen[sc]e'];

  licensePatternOfText = function(text) {
    var char, i, isRegExpChar, j, len, len1, pattern, ref, specialWord;
    pattern = '';
    isRegExpChar = false;
    ref = text.replace(/\s+/g, ' ');
    for (i = 0, len = ref.length; i < len; i++) {
      char = ref[i];
      if (isRegExpChar) {
        if (char === '~') {
          isRegExpChar = false;
        } else {
          pattern += char;
        }
      } else {
        switch (false) {
          case char !== '~':
            isRegExpChar = true;
            break;
          case !char.match(/[A-Za-z]/):
            pattern += char;
            break;
          case !char.match(/\s/):
            pattern += '\\s+';
            break;
          case !char.match(/[0-9]/):
            pattern += "\\s*" + char + "?\\s*";
            break;
          default:
            pattern += "\\s*\\" + char + "?\\s*";
        }
      }
    }
    for (j = 0, len1 = specialWords.length; j < len1; j++) {
      specialWord = specialWords[j];
      pattern = pattern.replace(new RegExp(specialWord, 'ig'), specialWord);
    }
    return new RegExp(pattern, 'i');
  };

  licenseMatchingMap = {
    'BSD': [/\bBSD\s+Licen[sc]e\b/i],
    'Apache-2.0': [/\bApache\s+Licen[sc]e\b([\s\S])*Version 2\.0/i],
    'MIT': [/\bMIT\s+Licen[sc]e(d)?\b/i, /\bLicen[sc]e(:)?\s+MIT\b/i, licensePatternOfText('Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated\ndocumentation files (the "Software"), to deal in the Software without restriction, including without\nlimitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of\nthe Software, and to permit persons to whom the Software is furnished to do so, subject to the following\nconditions:\n\nThe above copyright notice and this permission notice shall be included in all copies or substantial\nportions of the Software.\n\nTHE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT\nLIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.\nIN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,\nWHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE\nOR THE USE OR OTHER DEALINGS IN THE SOFTWARE.')],
    'Unlicense': [/unlicense\.org/i],
    'Public-Domain': [/\bPublic\s+Domain\b/i],
    'WTFPL': [/\bDO\s+WHAT\s+THE\s+FUCK\s+YOU\s+WANT\s+TO\s+PUBLIC\s+LICENSE\b/i],
    '#Chris-Andrews': [licensePatternOfText('Copyright ~[0-9]{4}~ Chris Andrews. All rights reserved.\n\nRedistribution and use in source and binary forms, with or without modification, are\npermitted provided that the following conditions are met:\n\n   1. Redistributions of source code must retain the above copyright notice, this list of\n      conditions and the following disclaimer.\n\n   2. Redistributions in binary form must reproduce the above copyright notice, this list\n      of conditions and the following disclaimer in the documentation and/or other materials\n      provided with the distribution.\n\nTHIS SOFTWARE IS PROVIDED BY CHRIS ANDREWS ``AS IS\'\' AND ANY EXPRESS OR IMPLIED\nWARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND\nFITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL CHRIS ANDREWS OR\nCONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR\nCONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR\nSERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON\nANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING\nNEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF\nADVISED OF THE POSSIBILITY OF SUCH DAMAGE.')]
  };

  module.exports = function(text) {
    var addSuffix, guessLicenses, matchesText, someExpressionMatchesText;
    matchesText = function(expression) {
      return expression.test(text);
    };
    someExpressionMatchesText = function(regularExpressions) {
      return some(regularExpressions, matchesText);
    };
    addSuffix = function(license) {
      return license + "*";
    };
    guessLicenses = flow(pickBy(someExpressionMatchesText), keys, map(addSuffix));
    return guessLicenses(licenseMatchingMap);
  };

}).call(this);
