// Generated by CoffeeScript 1.11.1
(function() {
  var filter, flatten, flow, guessLicenseFilename, guessLicenseText, isLicenseFilename, licenseRegExp, map, path, uniq;

  path = require('path');

  flow = require('lodash/flow');

  filter = require('lodash/fp/filter');

  map = require('lodash/fp/map');

  flatten = require('lodash/fp/flatten');

  uniq = require('lodash/uniq');

  guessLicenseText = require('./guess-license-text');

  guessLicenseFilename = require('./guess-license-filename');

  licenseRegExp = /\b((LICEN[SC]E)|(README))\b/i;

  isLicenseFilename = licenseRegExp.test.bind(licenseRegExp);

  module.exports = function(fs) {
    if (fs == null) {
      fs = require('fs');
    }
    return function(module) {
      var files, guessFile, guessFiles, guessedLicenses;
      guessFile = function(file) {
        var filename, text;
        filename = path.join(module.path, file);
        text = fs.readFileSync(filename, 'utf8');
        return guessLicenseText(text).concat(guessLicenseFilename(file));
      };
      guessFiles = flow(filter(isLicenseFilename), map(guessFile), flatten);
      guessedLicenses = [];
      if (module.files != null) {
        guessedLicenses = guessedLicenses.concat(guessFiles(module.files));
      }
      if ((module.path != null) && fs.existsSync(module.path)) {
        files = fs.readdirSync(module.path);
        guessedLicenses = guessedLicenses.concat(guessFiles(files));
      }
      if (module.readme != null) {
        guessedLicenses = guessedLicenses.concat(guessLicenseText(module.readme));
      }
      guessedLicenses = uniq(guessedLicenses);
      if (guessedLicenses.length > 0) {
        return guessedLicenses;
      }
      return null;
    };
  };

}).call(this);
