// Generated by CoffeeScript 1.11.1
(function() {
  var Promise, childProcess, execFile, execFileDangerously, fs, isYarnInUse;

  fs = require('fs');

  Promise = require('bluebird');

  childProcess = require('child_process');

  execFile = Promise.promisify(childProcess.execFile, {
    multiArgs: true
  });

  execFileDangerously = function(command, args, options) {
    return new Promise(function(resolve, reject) {
      return childProcess.execFile(command, args, options, function(error, stdout, stderr) {
        return resolve([stdout, stderr]);
      });
    });
  };

  isYarnInUse = function(cwd) {
    if (cwd == null) {
      cwd = process.cwd();
    }
    return fs.existsSync(cwd + "/yarn.lock");
  };

  module.exports = Promise.coroutine(function*(dev, modulePath) {
    var _execFile, options, stdout;
    if (dev == null) {
      dev = false;
    }
    options = {
      maxBuffer: 26 * 1024 * 1024
    };
    if (modulePath != null) {
      options.cwd = modulePath;
    }
    if (isYarnInUse(modulePath)) {
      console.log('yarn.lock found. Suppressing errors coming from npm ls.');
      _execFile = execFileDangerously;
    } else {
      _execFile = execFile;
    }
    stdout = (yield _execFile('npm', ['list', '--json', '--long', dev ? '--dev' : '--prod'], options))[0];
    return JSON.parse(stdout);
  });

}).call(this);
